/* 
 * Copyright (C) 2006, iRex Technologies B.V.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef XMGR_H_
#define XMGR_H_

#include <X11/Xlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#define Object XtObject
#include <Xm/XmAll.h>
#undef Object

#include "splash/SplashBitmap.h"
#include "splash/SplashTypes.h"

#define AppName     "iPdf"
#define MaxRGBCube  6

//////////////////////////////////////////////////////////////////////////
// XMgr:
// 1. manages all display, colormap, resouce and widgets 
// 2. provide simple image operation
//////////////////////////////////////////////////////////////////////////
class XMgr
{
public:
    XtAppContext    appContext;

    // display
    Display *       display;
    int             screenNum;
    Widget          appShell;       // top-level shell
    Widget          win;            // main window
    Widget          drawArea;       // view
    GC              drawAreaGC;     // view gc

    // color
    Visual *        visual;
    Colormap        colorMap;
    Gulong          colors[MaxRGBCube * MaxRGBCube * MaxRGBCube];
    int             rgbCubeSize;
    int             depth;     
    Gulong          mattePixel;
    XShmSegmentInfo * shmInfo;
    XImage *        shmImage;

public:
    XMgr(void);
    ~XMgr(void);
    void            setupColorMap();
    void            setupX(int * argc, char * argv[]);
    void            drawImage(SplashBitmap * bmp, 
			      int xSrc = 0, int ySrc = 0, 
			      int xDest = 0, int yDest = 0); 
};

#endif
